//
//  SchemScanViewController.h
//  SchemScan
//
//  Created by Christophe Guinchard on 05/06/11.
//  Copyright 2011. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "DT.h"
#import "Symbol.h"

@interface SchemScanViewController : UIViewController <UIScrollViewDelegate> {
	
	// Interface
	UIScrollView	*scrollView;
	UIView			*contentView;
	UISlider		*zoomSlider;
	UIBarButtonItem	*nextButton;
    UIBarButtonItem	*cancelButton;
	UIBarButtonItem	*readyLabel;
    
    // Gestures
    UIPinchGestureRecognizer    *pinchGestureRecognizer;
	
	// Models
	DT				*distanceTable;
	NSMutableArray	*symbolList;
	
	// Variables
	int				remainingOperation;
    
    int             selectedSymbolID;
    NSMutableArray  *validSymbolList;
    NSMutableArray  *displayedSymbolPointList;
    
    CGPoint     centerSelection;
    CGFloat     angleSelection;
    CGRect      rectSelection;
    CGSize      screenOrientationSize;
    
    // Layers
    CALayer     *selectionLayer;
    CALayer     *matchedLayer;
    

}

//Properties

    // Interface
    @property (nonatomic, retain)	IBOutlet	UIScrollView	*scrollView;
    @property (nonatomic, retain)	IBOutlet	UISlider		*zoomSlider;
    @property (nonatomic, retain)	IBOutlet	UIBarButtonItem	*nextButton;
    @property (nonatomic, retain)	IBOutlet	UIBarButtonItem	*cancelButton;
    @property (nonatomic, retain)	IBOutlet	UIBarButtonItem	*readyLabel;
    @property (nonatomic, retain)				UIView			*contentView;

    // Gesture
    @property (nonatomic, retain) UIPinchGestureRecognizer *pinchGestureRecognizer;

    // Models
    @property (nonatomic, retain)				DT				*distanceTable;
    @property (nonatomic, retain)				NSMutableArray	*symbolList;

    // Layers
    @property   (nonatomic, retain)	CALayer     *selectionLayer;
    @property   (nonatomic, retain)	CALayer     *matchedLayer;

    // Variables
    @property	int	remainingOperation;
    @property   int selectedSymbolID;
    @property   (nonatomic, retain) NSMutableArray  *validSymbolList;
    @property   (nonatomic, retain)	NSMutableArray	*displayedSymbolPointList;

    @property	CGPoint	centerSelection;
    @property	CGFloat	angleSelection;
    @property	CGRect	rectSelection;
    @property   CGSize  screenOrientationSize;


//Methods

    // Parsing
    -(int)	parseSSDT:	(NSString*)	path;
    -(int)	parseSSSB:	(NSString*)	path;

    // Matching
    -(void) matchSelection;

    // Actions
    -(IBAction) zoomAction:(id)sender;
    -(IBAction) nextAction:(id)sender;
    -(IBAction) cancelAction:(id)sender;

    // Gesture handlers
    -(void)		handlePinches:(UIPinchGestureRecognizer*)paramSender;

    // Conversion
    -(CGPoint) convertContentToSelectionLayer:(CGPoint) contentCoordinate;
    NSInteger distancesSort(id val1, id val2, void *context);

@end

